#ifndef __INC_ANIM__
#define __INC_ANIM__


struct str_Sprite{
	ushort	Idx;
	ushort	X,Y; // upon frame upper left
};

struct str_CBox{
	ushort	X,Y; // upon frame upper left
	ushort	Width;
	ushort	Height;
};

struct str_Frame {
	ushort	nbSprites;
	struct 	str_Sprite	*Sprites;
	ushort	nbCBoxes;
	struct 	str_CBox		*CBoxes;
	ulong		Timer;
	ushort	Next;
	ulong		Data;

//	CHAR	Name[256];
};

struct str_Anim {	
	ushort	Width, Height;
	ushort	nbFrames;
	struct	str_Frame		**Frames;
	ushort 	compressSize;
	uchar 	sprite_width;
	uchar 	sprite_height;
	ushort 	nbTiles;
	uint		*sprite_data;
//	WORD	activeFrame;
};


#define	MAX_ANIMS	( 10 )
struct AnimatedSprite 
{
	BOOL  	active;
	uchar 	IDCode;
	uchar	bhvIdx;
	uchar 	curFrame;
	uchar 	curTick;
	ushort	x;
	ushort	y;
	uchar 	palIdx;
	ushort 	idxTile;
	uchar	flip;
	struct 	str_Anim	*AnimLib;
	ushort	data;
}Anim[MAX_ANIMS];

extern 	struct AnimatedSprite	Anim[MAX_ANIMS];
extern	uchar					Anim_sprNumber;

extern struct str_Anim pieces_anim;

void	Anim_Init( );
ushort 	Anim_Load( struct str_Anim *AnimLib, ushort idxTile);
uchar	Anim_New( uchar IdCode, struct str_Anim *AnimLib, ushort firstTile, ushort posX, ushort posY, uchar pal);
void 	Anim_Delete( uchar idxSpr );
void	Anim_Update( );
void	Anim_Update1( );
void	Anim_Update2( );
BOOL	Anim_JumpTo( uchar idxSpr, uchar toFrame);


#endif