#include "genesis.h"
#include "control.h"
#include "level.h"
#include "game.h"
#include "anim.h"
#include "debug.h"

struct str_Level	curLevel;

extern	ushort	font[];
extern	ushort	font1[];

extern	ushort 	board_1P_width;
extern	ushort 	board_1P_height;
extern	ushort	board_1P[];
extern	ushort	board_pal[];
extern	ushort	board_tiles[];

extern	ushort	pieces_pal[]; // hero and font2 pal


uchar Logo_Text[16]="HERE IS THE LOGO";
uchar Intro_Text[18]="PDRC3.33 POOR GAME";
uchar Sommaire_Text[12]="TITLE SCREEN";
uchar Game_Text[10]="START GAME";
uchar Opt_Text[7]="OPTIONS";
uchar Credit_Text[7]="CREDITS";
uchar P1_Text[8]="1 PLAYER";
uchar P1P2_Text[9]="2 PLAYERS";
uchar P1CPU_Text[13]="PLAYER VS CPU";

uchar Next_Text[4] = "NEXT";
uchar Anim_Text[4] = "ANIM";


/****** LEVEL_INIT ******************
 * init a level
 *************************************/
void Level_Init( uchar levelNum, ushort firstTile )
{
	volatile ushort tileIdx; 
	ushort line, row;
	ushort tile;
	uchar i;
		
	ushort mypal[16]={
	0x000,
	0x1F1,
	0x22F,	
	0xF00,
	0x11F,
	0xF22,	
	0x0F0,
	0x1F1,
	0x22F,	
	0x0F0,
	0x11F,
	0xF22,	
	0xFF3
	};
	
	RAZ();
	Ctrl_Init( 20 );
	Anim_Init( );
	// def value
	curLevel.idx = levelNum;
	curLevel.width = 32;
	curLevel.height = 32;
	curLevel.pal = PAL0;
	curLevel.data = 0;
	
	unpack(font, GFX_WRITE_ADDR(32), 1007);
	tileIdx = 1 + 66;
	
	Gen_SetPal( PAL0, mypal);	
			
	switch( levelNum )
	{
		case LEVEL_LOGO:	
			tile = 0x8000 - 32 +1;
			for(i=0; i<16; i++)
			{
				Gen_ShowUnique(  8+i, 10, tile + Logo_Text[i], APLAN);
			}	
			return;			
			break;

		case LEVEL_INTRO:
			tile = 0x8000 - 32 +1;
			for(i=0; i<18; i++)
			{
				Gen_ShowUnique(  7+i, 10, tile + Intro_Text[i], APLAN);
			}	
			return;			
			break;		
		
		case LEVEL_SOM:
			tile = 0x8000 - 32 +1;
			for(i=0; i<12; i++)
			{
				Gen_ShowUnique(  10+i, 0, tile + Sommaire_Text[i], APLAN);
			}
			for(i=0; i<10; i++)
			{
				Gen_ShowUnique(  12+i, 10, tile + Game_Text[i], APLAN);
			}
			for(i=0; i<7; i++)
			{
				Gen_ShowUnique(  12+i, 11, tile + Opt_Text[i], APLAN);
			}
			for(i=0; i<7; i++)
			{
				Gen_ShowUnique(  12+i, 12, tile + Credit_Text[i], APLAN);
			}
			return;			
			break;

		case LEVEL_SOM2:
			tile = 0x8000 - 32 +1;
			for(i=0; i<12; i++)
			{
				Gen_ShowUnique(  10+i, 0, tile + Sommaire_Text[i], APLAN);
			}	
			for(i=0; i<8; i++)
			{
				Gen_ShowUnique(  12+i, 10, tile + P1_Text[i], APLAN);
			}	
			for(i=0; i<9; i++)
			{
				Gen_ShowUnique(  12+i, 11, tile + P1P2_Text[i], APLAN);
			}	
			for(i=0; i<13; i++)
			{
				Gen_ShowUnique(  12+i, 12, tile + P1CPU_Text[i], APLAN);
			}	
			return;			
			break;

		case LEVEL_OPT:
			return;			
			break;

		case LEVEL_CRED:
			return;			
			break;
			
		case LEVEL_GAME1:
			tile = 0x8000 - 32 +1;
			for(i=0; i<4; i++)
			{
				Gen_ShowUnique(  15+i, 4, tile + Next_Text[i], APLAN);
			}
				for(i=0; i<4; i++)
			{
				Gen_ShowUnique(  25+i, 4, tile + Anim_Text[i], APLAN);
			}

			unpack(board_tiles, GFX_WRITE_ADDR(tileIdx*32), 64);
			for (line=0;line<board_1P_height;line++)
			{
				for (row=0; row<board_1P_width;row++)
				{
					tile = board_1P[line*board_1P_width + row];
					if (tile)	tile+= (tileIdx+2);
					Gen_ShowUnique(row, line, tile, BPLAN);
				}
			}
			tileIdx+=6;
			curLevel.data = tileIdx;
			tileIdx = Anim_Load( &pieces_anim, tileIdx );

			Gen_SetPal( PAL2, pieces_pal);	
			Gen_SetPal( PAL3, board_pal);	
			
			Game_Init( 0 );
			return;			
			break;		

		case LEVEL_GAME2:
			Game_Init( 1 );
			return;			
			break;		

		case LEVEL_GAME3:
			Game_Init( 2 );
			return;			
			break;		
	}
}

/****** LEVEL_UPDATE ****************
 * update the current level
 *************************************/
void Level_Update(  )
{
	switch( curLevel.idx )
	{
		case LEVEL_LOGO:			
			if (vtimer >= 300)
			{
				Level_Init( LEVEL_INTRO, 1 );
				return;
			}
			break;
			
		case LEVEL_INTRO:
			if (Joypad1.key != 0)
			{
				Level_Init( LEVEL_SOM, 1 );
				return;
			}
			break;
			
		case LEVEL_SOM:
			Gen_ShowUnique(  10, 10+curLevel.data, 0x8000 - 32 +1 , APLAN);
			if (Joypad1.key & JOY_UP)
			{	
				(curLevel.data==0?curLevel.data=2:curLevel.data--);
			}
			else if (Joypad1.key & JOY_DOWN)
			{	
				(curLevel.data==2?curLevel.data=0:curLevel.data++);
			}
			else if (Joypad1.key & BUTTON_A)
			{	
				Level_Init( LEVEL_SOM2, 1 );
					return;
/*
				switch(curLevel.data)
				{
					case 0:
						Level_Init( LEVEL_SOM2, 1 );
						return;
						break;
					case 1:
						Level_Init( LEVEL_OPT, 1 );
						return;
						break;
					case 2:
						Level_Init( LEVEL_CRED, 1 );
						return;
						break;
				}
*/
			}
			Gen_ShowUnique(  10, 10+curLevel.data, 0x8000 - 32 +1 + 'O', APLAN);
			break;

		case LEVEL_SOM2:
			Gen_ShowUnique(  10, 10+curLevel.data, 0x8000 - 32 +1 , APLAN);
			if (Joypad1.key & JOY_UP)
			{	
				(curLevel.data==0?curLevel.data=2:curLevel.data--);
			}
			else if (Joypad1.key & JOY_DOWN)
			{	
				(curLevel.data==2?curLevel.data=0:curLevel.data++);
			}
			else if (Joypad1.key & BUTTON_A)
			{	
				Level_Init( LEVEL_GAME1, 1 );
				return;
/*
				switch(curLevel.data)
				{
					case 0:
						Level_Init( LEVEL_GAME1, 1 );
						return;
						break;
					case 1:
						Level_Init( LEVEL_GAME2, 1 );
						return;
						break;
					case 2:
						Level_Init( LEVEL_GAME3, 1 );
						return;
						break;
				}
*/
			}
			Gen_ShowUnique(  10, 10+curLevel.data, 0x8000 - 32 +1 + 'O', APLAN);
			break;
			
		case LEVEL_OPT:
			break;
		
		case LEVEL_CRED:
			break;												

		case LEVEL_GAME1:
		case LEVEL_GAME2:
		case LEVEL_GAME3:
			Game_Update( );
			break;			
	}
}