#ifndef __INC_PIECE__
#define __INC_PIECE__

#define	SHAPE_NONE	0
#define	SHAPE_O		1
#define	SHAPE_I		2
#define	SHAPE_S		3
#define	SHAPE_Z		4
#define	SHAPE_L		5
#define	SHAPE_J		6
#define	SHAPE_T		7



struct Piece{
	uchar 	nCurFrame; //current frame of piece (4 max)
	char	nX, nY;	//current position of piece
	uchar	nIDShape; //shape id
	uchar	bDropping; //true if currently dropping
	uchar	nAnimIdx;
	uchar	nMinFrame, nMaxFrame;
	uchar	aMask[4][4];
};

uchar Piece_Random( );
void Piece_Reset( struct Piece *P);
void Piece_Init( struct Piece *P, uchar IDShape);
void Piece_Update( struct Piece *P);

BOOL Piece_Down( struct Piece *P, uchar *RefArray );
BOOL Piece_Left( struct Piece *P, uchar *RefArray );
BOOL Piece_Right( struct Piece *P, uchar *RefArray );
BOOL Piece_RotateL( struct Piece *P, uchar *RefArray );
BOOL Piece_RotateR( struct Piece *P, uchar *RefArray );

#endif